// index.js
// 获取应用实例
const app = getApp()

Page({
  data: {
    items: [
      { value: 'SIGN', name: '签署', checked: 'true' },
      { value: 'AUTH', name: '认证授权' },
    ],
    envs: [
      { value: 'sml', name: '模拟环境' },
      { value: 'prod', name: '线上环境' },
    ],
    env: 'sml',
    envName: '模拟环境',
    group: '',
    url: '',
    h5url: '',
    flowId: '',
    accountId: '',
    type: 'SIGN',
    motto: '示例DEMO',
    userInfo: {},
    hasUserInfo: false,
    canIUse: wx.canIUse('button.open-type.getUserInfo'),
    canIUseGetUserProfile: false,
    canIUseOpenData: wx.canIUse('open-data.type.userAvatarUrl') && wx.canIUse('open-data.type.userNickName'), // 如需尝试获取用户信息可改为false
  },

  goIdentify(e) {
    // 开发者微信小程序内跳转到公证签小程序内打开e签宝的认证授权/签署页面
    // 场景一：直接跳转公证签小程序内操作认证授权/签署
    console.log('---goIdentify:', this.data)
    const { flowId, accountId, type, env, group } = this.data
    wx.navigateToMiniProgram({
      appId: 'wx1cf2708c2de46337', // 公证签小程序APPID
      path: '/pages/index/index', // webview页面地址
      extraData: {
        // 入参
        requestObj: {
          flowId, // 签署：signFlowId，认证授权：authFlowId
          accountId, // 个人账号ID（即：psnId ，仅签署需要）
          type, // 业务类型：签署 SIGN（默认）, 认证授权 AUTH
          env, // 环境，沙箱环境为：sml，正式环境为：prod
          group, // 项目环境分组标识
        },
        // 回传数据：签署/授权认证完成后会将此数据完整回传
        callbackObj: {
          from:'esign',
          flag:'某个开发者自定义的唯一标识，如业务编号'
        },
      },
      envVersion: env === 'test' ? 'trial' : 'release', // 仅针对开发或体验版有效，线上无效
      success(res) {
        // 根据客户自身需要
      },
      fail(res) {
        // 根据客户自身需要
      },
      complete(res) {
        // 根据客户自身需要
      },
    })
  },

  goUrl() {
    // 开发者微信小程序内通过WebView打开e签宝的认证授权/签署页面
    // 场景二：当前小程序内打开H5页面操作认证授权/签署
    const url = this.data.url
    wx.navigateTo({
      url: '../webview/index?url=' + encodeURIComponent(url),
    })
  },

  goUrlRedirect() {
    // 开发者微信小程序内通过WebView打开e签宝的认证授权/签署页面
    // 不使用刷脸认证且不希望跳转到公证签小程序，希望e签宝认证授权/签署页面可以直接跳回开发者微信小程序
    const h5url = this.data.h5url
    wx.navigateTo({
      url: '../redirectwv/index?url=' + encodeURIComponent(h5url),
    })
  },
  inputH5Url(e) {
    this.setData({
      h5url: e.detail.value,
    })
  },
  inputUrl(e) {
    this.setData({
      url: e.detail.value,
    })
  },
  clearUrl() {
    this.setData({
      url: '',
    })
  },
  bindPickerChange: function (e) {
    console.log('picker发送选择改变，携带值为', e.detail.value)
    const item = this.data.envs[e.detail.value]
    this.setData({
      env: item.value,
      envName: item.name,
    })
  },
  clearIds() {
    const items = this.data.items
    const value = 'SIGN'
    items.forEach((item) => {
      item.checked = item.value === value
    })
    this.setData({
      items,
      flowId: '',
      accountId: '',
      type: value,
    })
    console.log(this.data.type)
  },
  inputGroup(e) {
    this.setData({
      group: e.detail.value,
    })
  },
  inputFlowId(e) {
    this.setData({
      flowId: e.detail.value,
    })
  },
  inputAccountId(e) {
    this.setData({
      accountId: e.detail.value,
    })
  },
  radioChange(e) {
    const items = this.data.items
    const value = e.detail.value
    items.forEach((item) => {
      item.checked = item.value === value
    })
    this.setData({
      items,
      type: value,
    })
  },
  getUserProfile(e) {
    // 推荐使用wx.getUserProfile获取用户信息，开发者每次通过该接口获取用户个人信息均需用户确认，开发者妥善保管用户快速填写的头像昵称，避免重复弹窗
    wx.getUserProfile({
      desc: '展示用户信息', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
      success: (res) => {
        console.log(res)
        this.setData({
          userInfo: res.userInfo,
          hasUserInfo: true,
        })
      },
    })
  },
  getUserInfo(e) {
    // 不推荐使用getUserInfo获取用户信息，预计自2021年4月13日起，getUserInfo将不再弹出弹窗，并直接返回匿名的用户个人信息
    console.log(e)
    this.setData({
      userInfo: e.detail.userInfo,
      hasUserInfo: true,
    })
  },
})
